
public aspect Tracer3 {

  // pointcuts

  pointcut theMainMethod() : execution(public static void main(String[]));
  pointcut theSCall(): call(* HiWorld.printMsg(String));
  pointcut theNCall(): call(* HiWorld.printMsg(int));

  // advice

  before(): theMainMethod() {
    System.out.println("before the Main");
  }

  //after() returning : theMainMethod() {
  after() : theMainMethod() {
    System.out.println("after the Main");
  }

  before(): theSCall() {
    System.out.println("-- before the string msg call --");
  }

  after(): theSCall() {
    System.out.println("-- after the string msg call --");
  }
  before(): theNCall() {
    System.out.println("-- before the int msg call --");
  }

  after(): theNCall() {
    System.out.println("-- after the int msg call --");
  }
  

}

