
public aspect Tracer4 {

  // pointcuts

  pointcut theMainMethod() : execution(public static void main(String[]));
  //pointcut theSCall(): call(* HiWorld.printMsg(String));
  //pointcut theNCall(): call(* HiWorld.printMsg(int));
  pointcut theXCall(): call(* *.printMsg(*));

  // advice

  before(): theXCall() {
    System.out.println("before all printMsg in any class");
  }

  after(): theXCall() {
    System.out.println("after all printMsg in any class");
  }

  before(): theMainMethod() {
    System.out.println("before the Main");
  }

  //after() returning : theMainMethod() {
  after() : theMainMethod() {
    System.out.println("after the Main");
  }

/*
  before(): theSCall() {
    System.out.println("-- before the string msg call --");
  }

  after(): theSCall() {
    System.out.println("-- after the string msg call --");
  }
  before(): theNCall() {
    System.out.println("-- before the int msg call --");
  }

  after(): theNCall() {
    System.out.println("-- after the int msg call --");
  }
  
*/

}

