
public aspect Tracer2 {

  // pointcuts

  pointcut theMainMethod() : execution(public static void main(String[]));
  pointcut theCall(): call(* HiWorld.printMsg(String));

  // advice

  before(): theMainMethod() {
    System.out.println("before the Main");
  }

  //after() returning : theMainMethod() {
  after() : theMainMethod() {
    System.out.println("after the Main");
  }

  before(): theCall() {
    System.out.println("-- before the call --");
  }

  after(): theCall() {
    System.out.println("-- after the call --");
  }
  

}

